﻿Public Class VAPlugin_VB

    'NOTE THAT THIS IS A SAMPLE CLASS AND IS NOT FOR ANY MEANINGFUL USE.
    'You will want to gut this completely if you plan on using it... lol

    Public Shared Function VA_DisplayName() As String
        Return "My VoiceAttack VB Plugin"
    End Function

    Public Shared Function VA_Id() As Guid
        Return New Guid("{65183525-4D75-40eb-84D4-2CB698D713DB}")  'this id must be generated by YOU... it must be unique so VoiceAttack can identify and use the plugin
    End Function

    Public Shared Function VA_DisplayInfo() As String
        Return "My VoiceAttack Plugin\r\n\r\nThis is just a sample.\r\n\r\n2016 VoiceAttack"  'this is just extended info that you might want to give to the user.  note that you should format this up properly.
    End Function

    'this function is called from VoiceAttack when the 'stop all commands' button is pressed or a, 'stop all commands' action is called.  this will help you know if processing needs to stop if you have long-running code
    Public Shared Sub VA_StopCommand()

    End Sub

    'note that in this version of the plugin interface, there is only a single object parameter.  All the functionality of the previous parameters can be found in vaProxy
    Public Shared Sub VA_Init1(vaProxy As Object)

        'this is where you can set up whatever session information that you want.  this will only be called once on voiceattack load, and it is called asynchronously.
        'the SessionState property is a local copy of the state held on to by VoiceAttack.  In this case, the state will be a dictionary with zero items.  You can add as many items to hold on to as you want.
        'note that in this version, you can get and set the VoiceAttack variables directly.

        vaProxy.SessionState.Add("stateValue1", "some value here that I might need")  'add whatever private state information you want to maintain
        vaProxy.SessionState.Add("stateValue2", 444)
        vaProxy.SessionState.Add("currentDate", DateTime.Now)

        vaProxy.SetText("initializedVBText1", "This is Vee Bee 1")  'add some meaningless example text values
        vaProxy.SetText("initializedVBText2", "This is Vee Bee 2")

        vaProxy.SetInt("initializedInt1", 55)  'set some meaningless example integer values
        vaProxy.SetInt("initializedInt2", 77)

        vaProxy.SetDecimal("initializedDecimal1", 44.2)  'set some meaningless example decimal values
        vaProxy.SetDecimal("initializedDecimal2", -99.9)

        vaProxy.SetBoolean("initializedBoolean1", True)  'set some meaningless example boolean values
        vaProxy.SetBoolean("initializedBoolean2", False)

        vaProxy.SetSmallInt("initializedSmallInt1", 1)  'add some meaningless example small integers
        vaProxy.SetSmallInt("initializedSmallInt2", 2)

    End Sub

    Public Shared Sub VA_Exit1(vaProxy As Object)

        'this function gets called when VoiceAttack is closing (normally).  You would put your cleanup code in here, but be aware that your code must be robust enough to not absolutely depend on this function being called
        If (vaProxy.SessionState.ContainsKey("myStateValue")) Then
            'do some kind of file cleanup or whatever at this point
        End If
    End Sub

    Public Shared Sub VA_Invoke1(vaProxy As Object)


        'This function is where you will do all of your work.  When VoiceAttack encounters an, 'Execute External Plugin Function' action, the plugin indicated will be called.
        'in previous versions, you were presented with a long list of parameters you could use.  The parameters have been consolidated in to one, 'vaProxy' parameter of type Object.

        'vaProxy.Context - a string that can be anything you want it to be.  this is passed in from the command action.  this was added to allow you to just pass a value into the plugin in a simple fashion (without having to set conditions/text values beforehand).  Convert the string to whatever type you need to.

        'vaProxy.SessionState - all values from the state maintained by VoiceAttack for this plugin.  the state allows you to maintain kind of a, 'session' within VoiceAttack.  this value is not persisted to disk and will be erased on restart. other plugins do not have access to this state (private to the plugin)

        'the SessionState dictionary is the complete state.  you can manipulate it however you want, the whole thing will be copied back and replace what VoiceAttack is holding on to


        'the following get and set the various types of variables in VoiceAttack.  note that any of these are nullable (can be nothing and can be set to nothing).  in previous versions of this interface, these were represented by a series of dictionaries

        'vaProxy.SetSmallInt and vaProxy.GetSmallInt - use to access short integer values (used to be called, 'conditions')
        'vaProxy.SetText and vaProxy.GetText - access text variable values
        'vaProxy.SetInt and vaProxy.GetInt - access integer variable values
        'vaProxy.SetDecimal and vaProxy.GetDecimal - access decimal variable values
        'vaProxy.SetBoolean and vaProxy.GetBoolean - access boolean variable values
        'vaProxy.SetDate and vaProxy.GetDate - access date/time variable values

        'to indicate to VoiceAttack that you would like a variable removed, simply set it to nothing.  all variables set here can be used withing VoiceAttack.
        'note that the variables are global (for now) and can be accessed by anyone, so be mindful of that while naming


        'if the, 'Execute External Plugin Function' command action has the, 'wait for return' flag set, VoiceAttack will wait until this function completes so that you may check condition values and
        'have VoiceAttack react accordingly.  otherwise, VoiceAttack fires and forgets and doesn't hang out for extra processing.


        'below is just some sample code showing how to work with vaProxy.  There's more in the VoiceAttack help documentation that is installed with VoiceAttack (VoiceAttackHelp.pdf).

        If Not vaProxy.GetText("myVBTestValue") Is Nothing Then  'was the text value passed set?

            vaProxy.SetText("myVBTestValue", "hello " + New Random().Next(1, 6).ToString()) 'if the value is not nothing, this is a subsequent call... just change up the value to nonsense.  this value will go back to VoiceAttack (perhaps to be read with TTS or whatever)

        Else 'value has not been set.  set it here

            vaProxy.SetText("myVBTestValue", "this is new")

        End If

        Dim testShort As Short? = vaProxy.GetSmallInt("someValueIWantToClear")  'note that we are using Short? (nullable short) in case the value is null

        If testShort.HasValue Then
            vaProxy.SetSmallInt("someValueIWantToClear", Nothing)  'setting the value to nothing tells VoiceAttack that you want the variable removed
        End If


        'here we check the context to see if we should perform an action (with some additional examples of what can be done with vaProxy
        If vaProxy.Context = "fire weapons" Then

            If vaProxy.CommandExists("secret weapon") Then  'check if a command exists

                If vaProxy.ParseTokens("{ACTIVEWINDOWTITLE}") = "My Awesome Game" Then  'check the active window title using the parsetokens function

                    vaProxy.ExecuteCommand("secret weapon")  'this tells VoiceAttack to execute the, 'secret weapon' command by name (if the command exists)

                Else

                    vaProxy.WriteToLog("Your game was not active and on top.", "purple")

                End If

            Else

                vaProxy.WriteToLog("the secret weapon command does not exist.  you deleted it, didn't you?", "orange")

            End If

        End If


        'here we are adding some stuff to state
        Dim objValue As Object = Nothing
        Dim strStateValue As String = Nothing
        If (vaProxy.SessionState.TryGetValue("myStateValue", objValue)) Then  'we check to see if there is a value in state for 'myStateValue'
            strStateValue = objValue 'if we find something, we are going to cast it as a string and use it somewhere in here...
        Else
            strStateValue = "initialized"  'nothing was found in state... just set the string to, 'initialized' and keep moving...
        End If

        'hope that helps some!

    End Sub

End Class
